//+------------------------------------------------------------------+
//|                                                          vaZZ_sum|
//|                                              Copyright 2013,  J.B|
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, J.B"

#property version   "1.00"

#include <MovingAverages.mqh>

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_plots   1
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrBlack
#property indicator_style1  STYLE_SOLID
#property indicator_width1  3
#property indicator_label1  "vaZZ_sum"

input int vaMA_period=15;
input int cout_bar=1000;
input bool use_double_smooth=1;

double Sum_buffer[],EMA[],vaMA_buffer[],ZZhigh_buffer[],ZZlow_buffer[],ZZchange_buffer[],ZZchange_buffer2[];
//+------------------------------------------------------------------+
//| vaZZ_sum initialization function                                 |
//+------------------------------------------------------------------+  
void OnInit()
  {
   SetIndexBuffer(0,Sum_buffer,INDICATOR_DATA);
   SetIndexBuffer(1,EMA,INDICATOR_CALCULATIONS);
   SetIndexBuffer(2,vaMA_buffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(3,ZZhigh_buffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(4,ZZlow_buffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(5,ZZchange_buffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(6,ZZchange_buffer2,INDICATOR_CALCULATIONS);
  }
//+------------------------------------------------------------------+
//| vaZZ_sum iteration function                                      |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,const int prev_calculated,const int begin,const double &price[])
  {
   int first,bar,i;
   double vel,acc,aaa,M1,M2;

   ExponentialMAOnBuffer(rates_total,prev_calculated,begin,vaMA_period,price,EMA);

   if(rates_total<vaMA_period-1)return(0);
   if(prev_calculated==0)first=vaMA_period-1+begin;
   else first=prev_calculated-1;

   for(bar=first; bar<rates_total; bar++)
     {
      vel = EMA[bar]-EMA[bar-vaMA_period/4];
      acc = EMA[bar]-2*EMA[bar-vaMA_period/4]+EMA[bar-vaMA_period/8];
      aaa = EMA[bar]-3*EMA[bar-vaMA_period/4]+3*EMA[bar-vaMA_period/8]-EMA[bar-vaMA_period/12];
      vaMA_buffer[bar]=EMA[bar]+vel+acc/2+aaa/6;
     }

   if(use_double_smooth)
      ExponentialMAOnBuffer(rates_total,prev_calculated,begin,vaMA_period/4,vaMA_buffer,vaMA_buffer);

   for(bar=rates_total-cout_bar; bar<rates_total; bar++)
     {
      ZZchange_buffer[bar]=0;
      ZZhigh_buffer[bar]=ZZlow_buffer[bar]=NULL;

      if(vaMA_buffer[bar-1]<vaMA_buffer[bar]) ZZchange_buffer[bar]=1;
      if(vaMA_buffer[bar-1]>vaMA_buffer[bar]) ZZchange_buffer[bar]=2;
     }
     
        for(bar=rates_total-cout_bar; bar<rates_total; bar++)
     {
      if(ZZchange_buffer[bar]-ZZchange_buffer[bar-1]==1)
         ZZhigh_buffer[bar-1]=price[bar-1];

      if(ZZchange_buffer[bar]-ZZchange_buffer[bar-1]==-1)
         ZZlow_buffer[bar-1]=price[bar-1];
     }

/*
   for(bar=rates_total-cout_bar; bar<rates_total; bar++)
     {
      if(ZZhigh_buffer[bar]>price[bar-1]) ZZhigh_buffer[bar]=ZZhigh_buffer[bar]; 
      if(ZZhigh_buffer[bar]<price[bar-1]) ZZhigh_buffer[bar]=-ZZhigh_buffer[bar];
      

      if(ZZlow_buffer[bar]>ZZlow_buffer[bar-1]) ZZlow_buffer[bar]=ZZlow_buffer[bar]; 
      if(ZZlow_buffer[bar]<ZZlow_buffer[bar-1]) ZZlow_buffer[bar]=-ZZlow_buffer[bar];
     }
*/
   for(bar=rates_total-cout_bar; bar<rates_total; bar++)
     {
     
      for(i=rates_total-cout_bar; i<bar; i++)
        {
         M1 +=ZZhigh_buffer[i]-ZZlow_buffer[i];
        }
      Sum_buffer[bar]=M1;
     }

   return(rates_total);
  }
//+------------------------------------------------------------------+
